;Example POOL program, you may use it,
;modify and distribute under GPL license.
;Authors: R&D Independent Team
;Source: www.pool-rnd.com

if not defined? "painter [include "painter.l]

;class for the Julia fractal:
to julia [:cRe (-0.7)] [:cIm 0.27015]
  use painter ;derived from painter

  ;implementation of the fractal formula:
  to formula :real :img :depth
    repeat :depth [
      let "oldRe :real
      let "oldIm :img
      let "real :oldRe^2 - :oldIm^2 + :cRe
      let "img 2 * :oldRe * :oldIm + :cIm
      let "m :real^2 + :img^2
      if :m > 4 [
        output repcount - (log 0.5 * (log :m 2) 2)
      ]
    ]
    output :depth + 2
  end

  setpalette "hot

  to depth :s op int (sqrt :s) * 400 end
  ;implementation of color scaling functions:
  to fcolor :idx output sqrt log :idx end
  to cscale op 1000 / fcolor :depth end
end
;--- end of julia class ---

